<template>
  <div>
    <div v-html="messageClient" class="alert alert-warning" role="alert" v-if="messageClient">
      {{ messageClient }}
    </div>
    <vue-simple-spinner v-if="pending === true"></vue-simple-spinner>
    <form v-if="!formSubmitedIsOK && pending === false">
      <div :class="champ.groupClass" v-for="champ in formRecommendation" :key="champ.index">
        <label :for="champ.id" :class="champ.labelClass">{{ champ.libelle }}<span v-if="champ.required"> *</span></label> <span v-if="champ.error != ''">{{ champ.error }}</span>
        <input v-if="champ.type !== 'select'" :type="champ.type" :ref="champ.id" :class="champ.inputClass" :id="champ.id" :placeholder="champ.placeHolder" v-model="champ.value" />
      </div>
      <button type="button" class="btn btn-success" @click="submitForm()">Envoyer</button>
    </form>
  </div>
</template>

<script>
import { antiSpam } from "../../_services/antispam";

const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_EMAIL_RECOMMENDATION = URL_API + "api/emails/recommendation";

export default {
  data() {
    return {
      formSubmitedIsOK: false,
      messageClient: "",
      emailAdmin: null,
      errorForm: false,
      pending: false,
      globalError: "",
      productUrl: window.location.href,
      formRecommendation: [
        {
          id: "champ1",
          libelle: "Nom Prénom",
          value: "",
          type: "text",
          required: true,
          placeHolder: "Jean Dupont",
          error: "",
          groupClass: "form-group",
          inputClass: "form-control",
          labelClass: ""
        },
        {
          id: "champ2",
          libelle: "Email de votre ami(e)",
          value: "",
          type: "email",
          required: true,
          placeHolder: "henri-martin@gmail.com",
          error: "",
          groupClass: "form-group",
          inputClass: "form-control",
          labelClass: ""
        },
        {
          id: "champ3",
          libelle: "Message",
          value: "",
          type: "text",
          required: true,
          placeHolder: "Votre message ...",
          error: "",
          groupClass: "form-group",
          inputClass: "form-control",
          labelClass: ""
        }
      ]
    };
  },
  methods: {
    checkForm(form) {
      form.forEach((field, index) => {
        field.error = "";
        if (field.value == "" && field.required == true) {
          field.error = "Ce champs est obligatoire";
          this.errorForm = true;
        }
      });
    },
    submitForm() {
      this.pending = true;
      this.errorForm = false;
      this.checkForm(this.formRecommendation);
      console.log(process.env.VUE_APP_NODE_ENV);
      if (process.env.VUE_APP_NODE_ENV != '') {
        if (this.errorForm == false) {
          this.$axios.defaults.headers.common = {};
          this.$axios
            .get("https://jsonip.com") // service tiers
            .then(response => {
              let ipUser = response.data.ip;
              let isSpam = antiSpam(ipUser);
              console.log(isSpam);
             if (isSpam === "spam protect") {
               console.log("in spam protect")
               this.pending = false;
               this.messageClient = "Protection anti-spam. Veuillez patienter";
             }
             else {
               console.log("No spam protect : " + isSpam)
               this.sendMailRecommendation();
             }
            })
            .catch(error => {
              console.log("message", error);
            });
        }
      } else {
        this.sendMailRecommendation();
      }
    },
    sendMailRecommendation() {
      this.$axios.defaults.headers.common["siteHost"] = process.env.VUE_APP_DB_HOST;
      this.$axios.defaults.headers.common["siteDatabase"] = process.env.VUE_APP_DB_DATABASE;
      this.$axios.defaults.headers.common["siteUsername"] = process.env.VUE_APP_DB_USER;
      this.$axios.defaults.headers.common["sitePassword"] = process.env.VUE_APP_DB_PASSWORD;
      this.$axios.defaults.headers.common["siteName"] = process.env.VUE_APP_SITE_ALIAS;
      this.$axios.defaults.headers.common["siteKey"] = process.env.VUE_APP_SITE_KEY;
      this.pending = true;
      let payload = {
        emailSender: "recommandation@arpaline.net",
        subject: "Un ami vous recommande cet article !",
        emailsTO: [this.formRecommendation[1].value],
        emailsCC: [],
        emailsBCC: [],
        dataForm: JSON.stringify(this.formRecommendation),
        productUrl: JSON.stringify(this.productUrl)
      };

      this.$axios
        .post(URL_EMAIL_RECOMMENDATION, payload)
        .then(response => {
          if (response.data.data == "Email OK") {
            this.pending = false
            this.messageClient = "La recommendation a été transmise.";
            this.formSubmitedIsOK = true;
            this.formRecommendation.forEach(el => {
              el.value = "";
            });
          } else {
            this.pending = false
            this.messageClient = "Un problème serveur est survenu, la recommendation n'a pas pu etre transmise.";
          }
        })
        .catch(error => {
          console.log("error", error);
        });
    }
  }
};
</script>
